# -*- coding: UTF-8 -*-

from ij import IJ, ImageJ
from array import array,zeros 
import itertools
#from pylab import plot, ginput, show, axis
import copy
import sys
import os
import math
import java.awt
import ij.gui.Plot
import java.lang.String
import java.awt.Color
import java.awt.Graphics
import java.awt.BorderLayout
import csv
import weka.core.Debug as Debug
import weka.core.SelectedTag as SelectedTag
import java.io.BufferedReader as BufferedReader
import java.io.FileReader as FileReader
import weka.core.Instances as Instances
import weka.core.DenseInstance as DenseInstance
import weka.core.Attribute as Attribute
import weka.core.FastVector as FastVector

from javax.swing import JFrame, JLabel, JPanel, JFileChooser
from datetime import datetime
from java.lang import Double
#import org.python.core.Options
#import java.awt.MouseInfo as MouseInfo
import ij.process.FloatProcessor as FloatProcessor
import ij.plugin.frame.RoiManager as RoiManager
import ij.plugin.filter.ParticleAnalyzer as ParticleAnalyzer
import ij.measure.Measurements as Measurements
from ij import IJ, ImagePlus, ImageStack, CompositeImage#, Overlay  
import ij.gui.Overlay as Overlay
import ij.gui.ImageRoi as ImageRoi
import ij.gui.Plot as Plot
import ij.gui.PlotWindow as PlotWindow
import ij.measure.ResultsTable as ResultsTable
import ij.plugin.frame.RoiManager
import java.awt.Color as Color

import ij.ImagePlus
import java.lang.Cloneable
from jarray import array,zeros 
import java.util.Arrays as Arrays
import javax.swing.JApplet
import java.awt.Window as Window
import java.awt.Toolkit as Toolkit
import java.awt.Dimension as Dimension
from sys import path
import ij.io.DirectoryChooser as DirectoryChooser
#from java.lang.System import getProperty
import segmentation.WekaHandler as WekaHandler

#path.append(getProperty('fiji.dir') + '/functions')
#path.append('/functions')

from funsSegm import *
from funsAnalyzer import *
#path.append(getProperty('fiji.dir') + '/graphcut')
from graphcut import Graph_Cut
from classify import classify

###################################################################################
def ParticleAnal(imp,ThrDiam, dXpixNorm):
        
    table1 = ResultsTable() # ELLIPSES
# Create a hidden ROI manager, to store a ROI for each blob or cell
    roim = RoiManager(True)
    pa = ParticleAnalyzer(ParticleAnalyzer.SHOW_OVERLAY_MASKS,Measurements.ELLIPSE+Measurements.AREA, table1, 0, Double.POSITIVE_INFINITY, 0.0, 1.0)
    #pa = ParticleAnalyzer(ParticleAnalyzer.ADD_TO_MANAGER+ParticleAnalyzer.SHOW_MASKS,Measurements.ELLIPSE, table1, 0, Double.POSITIVE_INFINITY, 0.0, 1.0)
    pa.setHideOutputImage(True)
# The measured areas are listed in the first column of the results table, as a float array:
    pa.analyze(imp)
    #mask = pa.getOutputImage() 
    
# ELLIPSE PARAMETERS + AREAS
    a = table1.getColumn(table1.getColumnIndex('Major'))   # major axis of fitted ellipse
    b = table1.getColumn(table1.getColumnIndex('Minor'))   # minor axis of fitted ellipse
    angle = table1.getColumn(table1.getColumnIndex('Angle'))   # angle of major axis measured to x axis
    areas = table1.getColumn(table1.getColumnIndex('Area'))   # areas of islets
  
    # THRESHOLDING OF SMALL OBJECTS
    #ThrDiam = 20
    NrPixThr = math.pi*math.pow(0.5*ThrDiam/dXpixNorm,2)   # pixel Area for given circular diameter 
    Thr = NrPixThr    # number of pixels contained in objects, threshold
    areasThr = []
    aThr = []
    bThr = []
    angleThr = []

    for ar in areas:
        if ar > Thr:
            areasThr.append(ar)

    for ind in range(0,len(areas)):
        if areas[ind] > Thr:
            aThr.append(a[ind])
            bThr.append(b[ind])
            angleThr.append(angle[ind])
    areas = areasThr
    a = aThr
    b = bThr
    angle = angleThr
    return areas, a, b, angle



############################
#  CLASSIFIER READING
############################

def run():
    fc= JFileChooser('C:\JS\KLASIFIKATORY')
    fc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES)
    panel = JPanel()
    result = fc.showDialog(panel,"Pick a trained classifier")
    
    
    if result == JFileChooser.APPROVE_OPTION:
            Clfile = fc.getSelectedFile()
            Clfilename = fc.getName(Clfile)
    else:
            frameErr1 = JFrame('ERROR', size = (300,150))
            label1 = JLabel('Directory was not opened', JLabel.CENTER)
            label1.setFont (label1.getFont().deriveFont(18.0))
            frameErr1.add(label1)
            frameErr1.visible = True
        
    print Clfilename
    
    MuClass = Debug.loadFromFile(str(Clfile))
    
    ############################
    # NACTENI DAT PRO TRENOVANI
    ############################
    
    dirChoos = DirectoryChooser("Pick a directory contained images")
    srcDir = dirChoos.getDirectory()   
    
    if srcDir is None:
            frameErr1 = JFrame('ERROR', size = (200,200))
            label1 = JLabel('Directory was not opened', JLabel.CENTER);
            frameErr1.add(label1)
            frameErr1.visible = True
    
    print srcDir
    frameRun = JFrame('RUNNING ...', size = (600,100))
    
    NoFile = 0
    #def ImageSeg(root,filenames):
    for root, dirs, filenames in os.walk(srcDir):
        for fname in filenames:
            # Skip seg files
            if fname.startswith("seg"):
                continue 
            elif fname.startswith("over"):
                continue
            elif fname.startswith("prob"):
                continue  
            elif fname.endswith(".csv"):
                continue 
            elif fname.startswith("gt"):
                continue     
            elif fname.startswith(".gitignore"):
                continue     
            NoFile = NoFile + 1
            # panel with segmented image
            labelNrfile = JLabel('Current / No of images: ' + str(NoFile) + ' / ' + str(len(filenames))+ '  ', JLabel.RIGHT)  # zobrazeni segnentovanych snimku
            labelNrfile.setFont (labelNrfile.getFont().deriveFont(18.0))
            frameRun.add(labelNrfile)
            frameRun.visible = True
            print len(filenames)
            labelfile = JLabel('  '+fname, JLabel.LEADING)  # zobrazeni segnentovanych snimku
            labelfile.setFont (labelfile.getFont().deriveFont(18.0))
            frameRun.add(labelfile)
            frameRun.visible = True
            #print fname
            path1 = os.path.join(root,fname)
            # print path1
            impTst = IJ.openImage(path1)
            #IJ.run(impTst,"Size...","width=500 height=375")
            #impTst.show()
            ipTst = impTst.getProcessor()#.convertToFloat() # as a copy  
            piximgTst = ipTst.getPixels()
            redTst = ipTst.toFloat(0, None)  
            Rtst = redTst.getPixels()
            greenTst = ipTst.toFloat(1, None)  
            Gtst = greenTst.getPixels()
            blueTst = ipTst.toFloat(2, None)  
            Btst = blueTst.getPixels()
            Lpiximg= len(piximgTst)
            isTestingSet = CreateDataInst()
            testD = DenseInstance(4)
            for i in range(len(piximgTst)):
                hsb = Color.RGBtoHSB(int(Rtst[i]),int(Gtst[i]),int(Btst[i]),None)
                
                testD.setValue(0,hsb[0])   # R
                testD.setValue(1,hsb[1])     # G
                testD.setValue(2,hsb[2])     # B
                isTestingSet.add(testD)
                #print i
            pixelsSegm = [0]*len(Rtst)
            labelProb = [0]*len(Rtst)
            print isTestingSet.numInstances()
            print isTestingSet.numAttributes()
            for k in range(isTestingSet.numInstances()):
                pixelsSegm[k] = MuClass.classifyInstance(isTestingSet.instance(k)) 
                labelProb[k] = MuClass.distributionForInstance(isTestingSet.instance(k))
            del isTestingSet 

            pixSegm, labelProb1 =   classify(impTst, MuClass)
            if pixelsSegm==pixSegm: print "pixSegm OK"
            if labelProb==labelProb1: print "labelProb OK"
            
            classifier = WekaHandler(MuClass, impTst.getWidth(), impTst.getHeight())
            segment = classifier.getSegmentation(impTst)
            distribs = classifier.getProbabilities(impTst)

            #print pixelsSegm   
            ipSeg = FloatProcessor(impTst.width, impTst.height, pixelsSegm, None)  
            PixIslProb, PixBkgProb, PixExoProb = PixProbFun(Rtst,labelProb)
                        
            ipProbIsl = FloatProcessor(impTst.width, impTst.height, PixIslProb, None)  # probability image
            ipProbBkg = FloatProcessor(impTst.width, impTst.height, PixBkgProb, None)
            ipProbExo = FloatProcessor(impTst.width, impTst.height, PixExoProb, None)
                   
            seg = 'seg_' + str(Clfilename) + '_' + fname[0:len(fname)-4] + '.png'
            segGC = 'segGC_' + str(Clfilename) + '_' + fname[0:len(fname)-4] + '.png'
            prob = 'prob_' + str(Clfilename) + '_' + fname[0:len(fname)-4] + '.png'
            pathSeg = os.path.join(root,seg)
            pathGC = os.path.join(root,segGC)
            impSeg = ImagePlus(seg, ipSeg) 
            #impSeg.show()
         
            pathProb = os.path.join(root,prob)
            imsProb = ImageStack(impTst.width,impTst.height)
            imsProb.addSlice(ipProbIsl)
            #imsProb.addSlice(ipProbBkg)
            #imsProb.addSlice(ipProbExo)
            impProb = ImagePlus(prob,imsProb) 
            print impProb.getBitDepth()   

            ###############################
            # GRAPH CUT
            ###############################
            GC = Graph_Cut()
            impGC = GC.processSingleChannelImage(impProb,None, float(0.5), float(500), float(500))
            impGC.show()
          
            #IJ.saveAsTiff(impProb,pathProb)
            #IJ.saveAs(impSeg,'.png',pathSeg)   # segmentation based on classifier
            IJ.saveAs(impGC,'.png',pathGC)      # segmentattion based on Graph Cut
            frameRun.remove(labelfile)  # remove filename
            frameRun.remove(labelNrfile)
            #return impTst,ipSeg
          
            # OVERLAIED IMAGES
            #IJ.run(impTst,"Size...","width=1000 height=750")
            #IJ.run(impSeg,"Size...","width=1000 height=750")
            ipSeg = impSeg.getProcessor()
            SegRoi = ImageRoi(0,0,ipSeg)
            SegRoi.setOpacity(0.3)
            Over = Overlay(SegRoi) 
            impTst.setOverlay(Over)
            impTst.draw()
            #impTst.show()
            overL = 'over_' + str(Clfilename) + '_' + fname[0:len(fname)-4] + '.png'
            pathOver = os.path.join(root,overL)
            #IJ.saveAs(impTst,'.png',pathOver)
        
    frameRun.visible = False
    
    # creating of DONE frame
    frameDone = JFrame('DONE ...', size = (400,100))
    labelDone = JLabel('ALL IMAGES WERE SEGMENTED', JLabel.CENTER)  # vsechny L1outy probehly
    labelDone.setFont (labelDone.getFont().deriveFont(20.0))
    frameDone.add(labelDone)
    frameDone.visible = True
    
    ###################################################################################
    # ANALYZER
    ###################################################################################
    # CAMERA PARAMETERS READING FROM inicamera.txt
    finicam = open("inicamera.txt", "r+")
    optMagnifRow = finicam.readline()
    posSmc1 = optMagnifRow.find(';')
    posEql1 = optMagnifRow.find('=')
    dXpixNormRow = finicam.readline()
    posSmc2 = dXpixNormRow.find(';')
    posEql2 = dXpixNormRow.find('=') 
    ThrDiamRow = finicam.readline()
    posSmc3 = ThrDiamRow.find(';')
    posEql3 = ThrDiamRow.find('=') 
    
    try:
        optMagnif = float(optMagnifRow[posEql1 + 1:posSmc1]) 
        dXpixNorm = float(dXpixNormRow[posEql2 + 1:posSmc2])
        ThrDiam = float(ThrDiamRow[posEql3 + 1:posSmc3])
    except:
        frameIni = JFrame('ERROR', size = (200,200))
        label = JLabel('Wrong inicamera.txt format', JLabel.CENTER)
        frameIni.add(label)
        frameIni.visible = True     
    finicam.close()
    #print 'Camera parameters read from inicamera.txt'
    #print 'Magnification of optics :  ' + str(optMagnif)
    #print 'Size of camera pixel [%sm]:  '%chr(181) + str(dXpixNorm)
    #print ThrDiam
    
    # PLOTTING OF CAMERA PARAMETERS
    ScreenSize = Dimension(Toolkit.getDefaultToolkit().getScreenSize())   # size of used screen
    Xwidth = ScreenSize.getWidth()
    Yheight = ScreenSize.getHeight()
    dXframe = 400     # width of Jframe
    dYframe = 80
    frameCam = JFrame('Camera parameters read from inicamera.txt', size = (dXframe,dYframe))
    label = JLabel('Size of camera pixel [%sm]:  '%chr(181) + str(dXpixNorm), JLabel.CENTER)
    label.setFont (label.getFont().deriveFont(18.0))
    frameCam.add(label)
    frameCam.setLocation(int(Xwidth)-dXframe,0)
    frameCam.visible = True     
    
    NoFile = 0
    #dirChoos = DirectoryChooser("Pick a directory contained segmentations")
    #srcDir = dirChoos.setDefaultDirectory(str(fpath))
    srcDir = dirChoos.getDirectory()   
    #srcDir = DirectoryChooser("Pick a directory contained segmentations").setDefaultDirectory(str(fpath))  
    #if srcDir is None:
    #      frameErr1 = JFrame('ERROR', size = (200,200))
    #      label1 = JLabel('Directory was not opened', JLabel.CENTER);
    #      frameErr1.add(label1)
    #      frameErr1.visible = True
           
    #print os.walk(srcDir)
    for root, dirs, filenames in os.walk(srcDir):
    #   print root
        for fname in filenames:
            # Skip non-PNG files
            if not fname.endswith(".png"):
                continue
            elif not fname.startswith("seg"):
                continue
            #elif not fname.startswith("seg"):
            #  continue  
            #print fname.find('.')
            #PosCut = fname.find('.')
            #fnameCut = fname[0:PosCut]   
            NoFile = NoFile + 1
            path1 = os.path.join(root,fname)
            imp = IJ.openImage(path1)
            IJ.run(imp,"Make Binary","")
            imp.show()
    #print root
            areas, a, b, angle = ParticleAnal(imp,ThrDiam,dXpixNorm)   
            aScale,bScale,areasMikro,AreaEllip,VolumeSph,VolumeSp150,VolumeEllip,DiaIsl,SumAreaPixel,SumAreaEllip,SumVolumeSph,SumVolumeEll,Lavg,NoIslet = ParamEval(a,b,areas,dXpixNorm,optMagnif)
    
            HistRicordi = HistRic(DiaIsl)       # we consider sphere
            HistRicLavg = HistRic(Lavg)         # we consider d = Lavg
            IsletRangePlot,IEQconvFact,IEQperRange,IEQperRangeLavg,IEQ_cal,TotIEQ,IEQperRangeEll,IEQperRangeSph,TotIEQEllip = ParamEvalHist(HistRicordi,HistRicLavg,areas,VolumeEllip,VolumeSp150,VolumeSph)  
            # HISTOGRAM PLOTTING
            plot = PlotWindow('Histogram of Islet Diameters', 'Islet Diameter Range [%sm]'%chr(181),'Frequency', IsletRangePlot, HistRicordi)
            plot.show()
            plot.setLineWidth(3)
            plot.setLimits(-10,710,0,max(HistRicordi)+10)
            #plot.setXYLabels(null,null)
            plot.addPoints(IsletRangePlot, (HistRicordi), Plot.BOX) 
    
            try:
                #fcsv = open(str(currpath) + '\Measurement.csv', 'wb')
                #fcsv = open(str(root) + '\Measurement.csv', 'wb')
                #fcsv = open(str(root) + '\Measurement_' + str(NoFile) + '.csv', 'wb')
                fcsv = open(str(root) + str(fname) + '.csv', 'wb')
                #fcsv = open(str(path) + '.csv', 'wb')
            except:
                frameErr = JFrame('ERROR', size = (200,200))
                label = JLabel('Close file of results', JLabel.CENTER);
                frameErr.add(label)
                frameErr.visible = True
    
            CurrTime = str(datetime.now())
            out = csv.writer(fcsv, delimiter=';')
            out.writerow(['Time of report creation:   ' + CurrTime[0:19]])
            out.writerow(['File name:   ' + str(fname),ThrDiam,'Diameter threshold [%sm]'%chr(181)] )
            out.writerow(['READ PIXEL SIZE FROM inicamera.txt [%sm]:'%chr(181),dXpixNorm] )
            out.writerow(['HISTOGRAM ACCORDING TO RICORDI:   '])
            out.writerow(['Islet circular diameter [%sm]'%chr(181)] + IsletRangePlot)
            out.writerow(['Frequency'] + HistRicordi)
            out.writerow(['IEQ per range'] + IEQperRange)
            out.writerow(['IEQ per range - diameter: avg of ellipse axes'] + IEQperRangeLavg)
            out.writerow(['Index of islets'] + NoIslet)
            out.writerow(['(2a) MAJOR axis of ellipse length [%sm]'%chr(181)] + aScale)
    #out.writerow(aScale)
            out.writerow(['(2b) MINOR axis of ellipse length [%sm]'%chr(181)] + bScale)
    #out.writerow(bScale)
            out.writerow(['(d) AVERAGE length of axes of ellipses [%sm]'%chr(181)] + Lavg)
            out.writerow(['ANGLE of ellipses [%s]'%chr(176)] + angle)
    #out.writerow(['Index of islets'] + NoIslet)
    #out.writerow(angle)
            out.writerow(['(P1) AREA of object from pixels [%sm^2]'%chr(181)] + areasMikro)
    #out.writerow(areasMikro)
            out.writerow(['(P) AREA of object from ellipses [%sm^2]'%chr(181)] + AreaEllip)
    #out.writerow(AreaEllip)
            out.writerow(['(V) VOLUME of SPHERES [%sm^3]'%(chr(181))] + VolumeSph)
            out.writerow(['(V) VOLUME of ELLIPSOIDS [%sm^3]'%(chr(181))] + VolumeEllip)
            out.writerow(['Index of islets'] + NoIslet)
            out.writerow(['Diameters of islets computed from circle [%sm]'%(chr(181))] + DiaIsl)
            out.writerow(['IEQ - ratio between SPHERE volume and sphere volume with d = 150 %sm'%(chr(181))] + IEQperRangeSph)
            out.writerow(['IEQ - ratio between ELLIPSE volume and sphere volume with d = 150 %sm'%(chr(181))] + IEQperRangeEll)
            out.writerow(['Index of islets'] + NoIslet)
            out.writerow(['Total IEQ from CIRCLE', TotIEQ])
            out.writerow(['Total IEQ from ELLIPSE', TotIEQEllip])
            out.writerow(['Sum of areas computed from PIXELS [%sm^2]'%(chr(181)), SumAreaPixel])
            out.writerow(['Sum of areas computed from ELLIPSES [%sm^2]'%(chr(181)), SumAreaEllip])
            out.writerow(['Sum of volumes computed from SPHERES [%sL]'%(chr(181)), SumVolumeSph])
            out.writerow(['Sum of volumes computed from ELLIPSOIDS [%sL]'%(chr(181)), SumVolumeEll])
            out.writerow(['LO', len(areas)])
    #out.writerow(IEQperRangeEll)
            fcsv.close()


run()
