# -*- coding: UTF-8 -*-

from inputprocessor import GTReader as GTReader
from inputprocessor import ImageReader
from segmentation import EdgeDetector
from imgreader import PatternList
from IsletJ import Parameters
from IsletJ import Key
from IsletJ import GT
from IsletJ import RunningMode
from imgreader import DataAccess

from os.path import expanduser
from os.path import join
from ij import ImageStack, ImagePlus

data = join(expanduser("~"), "Langerhans")
inputdir = join(data, "36from9donors")
gt = GTReader(inputdir, "gt").getGT();
gt.show()

GT.resetMap();

probIslPath = join(inputdir,"out")
crop = 1

key = DataAccess(probIslPath, "pIsl")

patternEx = PatternList("gt")
patternEx.add("res")
patternEx.add("val")

gtSliceLabels = gt.getStack().getSliceLabels()

reader = ImageReader(key, patternEx, gtSliceLabels, crop);                    
prob = reader.getImg()
prob.show()

edgeStack = ImageStack(prob.getWidth(), prob.getHeight())

key = DataAccess(inputdir, "")
reader = ImageReader(key, patternEx, gtSliceLabels, crop)
img = reader.getImg()
imgStack = img.getStack()

for slice in range(0, gt.getImageStackSize()):
    imgIn = ImagePlus("", imgStack.getProcessor(slice+1))
    edges = EdgeDetector().getEdges(imgIn, 4.0, .2)
    edgeStack.addSlice(edges.getProcessor())

edgeImg = ImagePlus("edges", edgeStack)
edgeImg.show()
gcDataWeight = 0.5
#for gcPotsWeight in range(30,100+1, 10):
#    for gcEdgeWeight in range(30, 100+1, 10):
        